DROP SCHEMA ATT_MAN CASCADE;

CREATE SCHEMA ATT_MAN AUTHORIZATION POSTGRES;

CREATE TABLE ATT_MAN.ATTENDANCE (
	ATTENDANCE_ID INT8 NOT NULL,
	CLOCK_IN TIMESTAMP NOT NULL,
	CLOCK_OUT TIMESTAMP NULL,
	USER_ID INT8 NOT NULL,
	APPROVED_BY INT8 NULL,
	UPDATED_BY INT8 NOT NULL,
	ATTENDANCE_STATUS INT4 NOT NULL,
	REMARKS VARCHAR NULL,
	CONSTRAINT ATTENDANCE_PK PRIMARY KEY (ATTENDANCE_ID)
	CONSTRAINT ATTENDANCE_USER_LOGIN_FK FOREIGN KEY (USER_ID) REFERENCES ATT_MAN.USER_LOGIN(USER_ID) ON UPDATE CASCADE;
);
CREATE INDEX ATTENDANCE_USER_ID_IDX ON ATT_MAN.ATTENDANCE (USER_ID);
CREATE INDEX ATTENDANCE_APPROVED_BY_IDX ON ATT_MAN.ATTENDANCE (APPROVED_BY,ATTENDANCE_STATUS);
CREATE INDEX ATTENDANCE_UPDATED_BY_IDX ON ATT_MAN.ATTENDANCE (UPDATED_BY,ATTENDANCE_STATUS);
CREATE INDEX ATTENDANCE_CLOCK_IN_IDX ON ATT_MAN.ATTENDANCE (CLOCK_IN,CLOCK_OUT);

CREATE TABLE ATT_MAN.LEAVE (
	LEAVE_ID INT8 NOT NULL,
	USER_ID INT8 NOT NULL,
	LEAVE_START TIMESTAMP NOT NULL,
	LEAVE_END TIMESTAMP NOT NULL,
	LEAVE_TYPE INT4 NOT NULL,
	LEAVE_DURATION INT4 NOT NULL,
	APPROVED_BY INT8 NULL,
	UPDATED_BY INT8 NOT NULL,
	LEAVE_STATUS INT4 NOT NULL,
	REMARKS VARCHAR NULL,
	CONSTRAINT LEAVE_PK PRIMARY KEY (LEAVE_ID)
	CONSTRAINT LEAVE_USER_LOGIN_FK FOREIGN KEY (USER_ID) REFERENCES ATT_MAN.USER_LOGIN(USER_ID) ON UPDATE CASCADE;
);
CREATE INDEX LEAVE_USER_ID_IDX ON ATT_MAN.LEAVE (USER_ID,LEAVE_DURATION,LEAVE_START,LEAVE_END,LEAVE_TYPE);
CREATE INDEX LEAVE_APPROVED_BY_IDX ON ATT_MAN.LEAVE (APPROVED_BY,LEAVE_STATUS);
CREATE INDEX LEAVE_UPDATED_BY_IDX ON ATT_MAN.LEAVE (UPDATED_BY);

CREATE TABLE ATT_MAN.USER_LOGIN (
	USER_ID INT8 NOT NULL,
	USERNAME VARCHAR NOT NULL,
	PASSWORD VARCHAR NOT NULL,
	EMAIL VARCHAR NOT NULL,
	LOGIN_STATUS INT4 NOT NULL,
	CREATE_TIMESTAMP TIMESTAMP NOT NULL,
	UPDATE_TIMESTAMP TIMESTAMP NULL,
	UPDATED_BY INT8 NOT NULL,
	CONSTRAINT USER_LOGIN_PK PRIMARY KEY (USER_ID)
	CONSTRAINT USER_LOGIN_UNIQUE UNIQUE (USER_NAME);
);
CREATE INDEX USER_LOGIN_USER_NAME_IDX ON ATT_MAN.USER_LOGIN (USER_NAME,STATUS,EMAIL);

CREATE TABLE ATT_MAN.USER_PROFILE (
	PROFILE_ID INT8 NOT NULL,
	FIRST_NAME VARCHAR NOT NULL,
	LAST_NAME VARCHAR NOT NULL,
	USER_ID INT8 NOT NULL,
	DEPARTMENT VARCHAR NULL,
	"POSITION" VARCHAR NULL,
	CREATE_TIMESTAMP TIMESTAMP NOT NULL,
	UPDATE_TIMESTAMP TIMESTAMP NULL,
	UPDATED_BY INT8 NOT NULL,
	CONSTRAINT USER_PROFILE_PK PRIMARY KEY (PROFILE_ID)
	CONSTRAINT USER_PROFILE_UNIQUE UNIQUE (USER_ID)
	CONSTRAINT USER_PROFILE_USER_LOGIN_FK FOREIGN KEY (USER_ID) REFERENCES ATT_MAN.USER_LOGIN(USER_ID) ON DELETE CASCADE ON UPDATE CASCADE;
);
CREATE INDEX USER_PROFILE_FIRST_NAME_IDX ON ATT_MAN.USER_PROFILE (FIRST_NAME,LAST_NAME,USER_ID);
CREATE INDEX USER_PROFILE_DEPARTMENT_IDX ON ATT_MAN.USER_PROFILE (DEPARTMENT,"POSITION");

CREATE TABLE ATT_MAN.USER_ROLE (
	ROLE_ID INT8 NOT NULL,
	USER_ID INT8 NOT NULL,
	ROLE_TYPE INT4 NOT NULL,
	ROLE_STATUS INT4 NOT NULL,
	CREATE_TIMESTAMP TIMESTAMP NOT NULL,
	CREATED_BY INT8 NOT NULL,
	UPDATE_TIMESTAMP TIMESTAMP NULL,
	UPDATED_BY INT8 NULL,
	CONSTRAINT USER_ROLE_PK PRIMARY KEY (ROLE_ID)
	CONSTRAINT USER_ROLE_USER_LOGIN_FK FOREIGN KEY (USER_ID) REFERENCES ATT_MAN.USER_LOGIN(USER_ID) ON DELETE CASCADE ON UPDATE CASCADE;
);
CREATE INDEX USER_ROLE_USER_ID_IDX ON ATT_MAN.USER_ROLE (USER_ID,ROLE_STATUS,ROLE_TYPE);



